"use strict";

var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {
            try {
                step(generator.next(value));
            } catch (e) {
                reject(e);
            }
        }
        function rejected(value) {
            try {
                step(generator.throw(value));
            } catch (e) {
                reject(e);
            }
        }
        function step(result) {
            result.done ? resolve(result.value) : new P(function (resolve) {
                resolve(result.value);
            }).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
const Node_1 = require('./Node');
class Subject extends Node_1.Node {
    /**
     * Call resource method of the same name
     */
    determineAccess(resource, permissionType, options) {
        return __awaiter(this, void 0, Promise, function* () {
            return resource.determineAccess(this, permissionType, options);
        });
    }
    /**
     * Call resource method of the same name
     */
    isAllowed(resource, permissionType, options) {
        return __awaiter(this, void 0, Promise, function* () {
            return resource.isAllowed(this, permissionType, options);
        });
    }
    /**
     * Call resource method of the same name
     */
    explainPermission(resource, permissionType, options) {
        return __awaiter(this, void 0, Promise, function* () {
            return resource.explainPermission(this, permissionType, options);
        });
    }
}
exports.Subject = Subject;